<?php
//Gestione "centralizzata" metodi.
//Tutte le chiamate ai metodi del MOAS vengono effettuate in questo include,
//per una pi facile manutenzione...


//Funzione per convertire in maiuscolo tutte le chiavi di un array pluridimensionale...
function convert_key($ar_in, $tipo_conv)
{

	global $Ar_Msg, $nr_msg;

	if (is_array($ar_in))
	{
		//Convertiamo in maiuscolo le chiavi del vettore...
		$ar_out = array_change_key_case($ar_in, $tipo_conv);

		while (list ($chiave, $valore) = each($ar_out))
		{

			//Gestione dei messaggi...
			if (strtoupper($chiave) == "__MESSAGE")
			{
				$app_val_msg = explode(";", $valore);

				$Ar_Msg[$nr_msg]['typ'] = $app_val_msg[0];
				$Ar_Msg[$nr_msg]['msg'] = $app_val_msg[1];
				$Ar_Msg[$nr_msg]['wdt'] = $app_val_msg[2];
				$Ar_Msg[$nr_msg]['hgt'] = $app_val_msg[3];
				$Ar_Msg[$nr_msg]['top'] = $app_val_msg[4];
				$Ar_Msg[$nr_msg]['lft'] = $app_val_msg[5];
				$Ar_Msg[$nr_msg]['tit'] = $app_val_msg[6];
				$Ar_Msg[$nr_msg]['pos'] = $app_val_msg[7];

				//print_r($Ar_Msg[$nr_msg]['msg']) ;
				$nr_msg++;
			}

			//Se l'elemento del vettore  a sua volta un vettore, richimiamo ricorsivamente convert_key()
			if (is_array($valore))
			{
				$ar_ok = convert_key($valore, $tipo_conv);
				$ar_out[$chiave] = $ar_ok;
			}
		}
	}
	else
	{
		$ar_out = $ar_in;
	}

	return $ar_out;

}

//La funzione call_met() effettua la chiamata vera e propria al metodo e
//restituisce  la risposta del metodo o false a seconda dell'esito.

function call_met($nome_metodo, $parametri, $chiamante = NULL, $PortaPass = NULL)
{

	global $ses_moas, $dt_user, $Ar_Msg, $nr_msg, $appname,$server_host;
	global $MyDateFormat, $MyTimeFormat, $MyDateTimeFormat,$server_port,$VDateTimeFormat;
	
	global $messaggio, $msg_debug, $msg_tempo;

	if ($PortaPass != "")
		$xrpc_host = $server_host . ":" . $PortaPass;
	elseif (isset ($dt_user)) $xrpc_host = $server_host . ":" . $dt_user['PortaCorr'];
	else
		$xrpc_host = $server_host . ":" . $server_port;

	$parametri[0]['MethodName'] = $nome_metodo;

	//Scomposizione vettore parametri e decodifica Xml...
	$array_param = array ();
	reset($parametri);
	while (list ($K_param, $V_param) = each($parametri))
	{
		$array_param[] = XMLRPC_prepare($V_param);
	}

	############################################################################
	//DEBUG... per vedere cosa viene inviato al Moas, scommentare dove indicato
	$M_Debug = null;
	//Scommentare la riga sotto
	//$M_Debug = "ATTIVO";
	//Scommentare la riga sopra

	if ($M_Debug == "ATTIVO")
	{
		reset($parametri);
		$msg_debug .= "<br><b>Metodo: $nome_metodo</b> (Nr. elementi vettore 'parametri': " . sizeof($parametri) . ")<br>\n";
		for ($p = 0; $p < sizeof($parametri); $p++)
		{
			reset($parametri[$p]);
			if ($p == 0)
			{
				$msg_debug .= "<font color=\"blue\">-Parametri metodo:</font> ";
			}
			else
			{
				$msg_debug .= "<font color=\"blue\">-Parametro $p:</font> ";
			}
			while (list ($chiave, $valore) = each($parametri[$p]))
			{
				$msg_debug .= " <font color=\"red\">$chiave</font> ==> <font color=\"green\">$valore</font> -|-";
			}
			$msg_debug .= "<br>\n";
			reset($parametri[$p]);
		}
		reset($parametri);
	}
	############################################################################

	//Decodifica Xml array parametri...
	/*$array_param = array() ;
	$array_param[0] = XMLRPC_prepare($parametri) ;
	$array_param[1] = XMLRPC_prepare($param2) ;
	*/

	//Tempo
	$tempo_ini = getmicrotime();

	//Chiamata vera e propria del MOAS...
	list ($successo, $risposta) = XMLRPC_request($xrpc_host, '', 'moas', $array_param);

	//Tempo
	/*    echo "<pre>";
			print_r($nome_metodo);
			print_r($risposta);
			echo "</pre>";*/

	$tempo_ini = getmicrotime() - $tempo_ini;
	$msg_tempo .= "<b>Metodo: $nome_metodo ($tempo_ini)</b><br>\n";

	//Verifica risposta...
	if (!$successo)
	{
		$messaggio = "Errore di protocollo (cod: " . $risposta['faultCode'] . ") :&nbsp;" . $risposta['faultString'];

		$str_msg_fault = print_r($risposta["faultString"], true);
		$msg_fault = "Attention! Fault Message - FaultCode: " . $risposta["faultCode"] . " - FaultString: " . $str_msg_fault;
		$msg_fault = str_replace("\n", "", $msg_fault);

		//DIALOG per i messaggi di fault...
		$Ar_Msg[$nr_msg]['typ'] = "Alert";
		$Ar_Msg[$nr_msg]['msg'] = base64_encode($msg_fault);
		$Ar_Msg[$nr_msg]['wdt'] = "300";
		$Ar_Msg[$nr_msg]['hgt'] = "180";
		$Ar_Msg[$nr_msg]['top'] = "50";
		$Ar_Msg[$nr_msg]['lft'] = "50";
		$Ar_Msg[$nr_msg]['tit'] = "FAULT";
		$Ar_Msg[$nr_msg]['pos'] = "";

		$nr_msg++;

		if ($risposta["faultCode"] == "10532")
		{

			$str_user = "MSID^" . $dt_user['MSID'] . "|Nome^" . $dt_user['Nome'] . "|Cognome^" . $dt_user['Cognome'] . "|SqlDateTimeFormat^" . $dt_user['SqlDateTimeFormat'] . "|SqlDateFormat^" . $dt_user['SqlDateFormat'] . "|SqlTimeFormat^" . $dt_user['SqlTimeFormat'] . "|MyDateTimeFormat^" . $dt_user['MyDateTimeFormat'] . "|MyDateFormat^" . $dt_user['MyDateFormat'] . "|MyTimeFormat^" . $dt_user['MyTimeFormat'] . "|VDateTimeFormat^" . $dt_user['VDateTimeFormat'] . "|VDateFormat^" . $dt_user['VDateFormat'] . "|VTimeFormat^" . $dt_user['VTimeFormat'] . "|Compress^" . $dt_user['Compress'] . "|TemplDir^" . $dt_user['TemplDir'] . "|Separatore^" . $dt_user['Separatore'] . "|VSeparatore^" . $dt_user['VSeparatore'] . "|PortaCorr^" . $server_port;

			//Registriamo i dati...
			session_unregister("ses_moas");
			$ses_moas['User'] = $str_user;
			//session_register("ses_moas") ;
			$_SESSION['ses_moas'] = $ses_moas;

		}

		return $successo;
	}
	else
	{

		//Convertiamo in maiuscolo tutte le chiavi del vettore di risposta...
		$M_risp = convert_key($risposta, CASE_UPPER);

		return $M_risp;
	}

}
?>
