<?php

/**
 * converte un array formattato dalla classe array2xml in un xml
 * @package array2xml
 * @author Alessandro Vernassa <a.vernassa@teammosaico.biz>
**/

// compatibilit funzioni xmldom tra php4 e php5
if (version_compare(PHP_VERSION, '5', '>='))
	require_once ('domxml-php4-to-php5.php');

class array2xml
{

	///vars ....
	var $config /*=	array(
		'xmlns'	=>	array(
		'xml'	=>	'http://www.w3.org/1999/xhtml'
		)
	)*/;
	var $dom;

	function array2xml($array, $encoding)
	{
		$this->config['encoding'] = $encoding;

		if (!is_array($array))
			return false;
		$this->array = $array;
		$this->dom = domxml_new_doc("1.0");

	}

	/**
	 * setta la codifica dei caratteri dell' xml
	 * @name setEncoding
	 * @param string $enc
	 **/
	function setEncoding($enc)
	{
		$this->config['encoding'] = ($enc != '') ? $enc : $this->config['encoding'];
	}

	function getEncoding()
	{
		return $this->config['encoding'];
	}

	/*
		function addNamespaces( $assoc )
		{
			$this->config['xmlns'] = array_merge($this->config['xmlns'], $assoc);
		}*/

	function getResult($format = TRUE)
	{
		$doc_root = array_shift(array_keys($this->array));

		$root_element = $this->dom->create_element($doc_root);

		if (!is_object($root_element))
		{
			die("error to create element");
		}

		$this->_recArray2Node($root_element, $this->array[$doc_root]);
		$this->dom->append_child($root_element);
		$ns = null;

		// check for namespaces ? add each to doc
		/*if ( isset($this->used_namespaces) && is_array($this->used_namespaces) )
			foreach ($this->used_namespaces as $ns)
			{
				//dprint_r($ns);
				$root_element->add_namespace($this->config["xmlns"][ $ns ], $ns);
			}*/

		// <b>Warning</b>:  dump_mem(): xmlDocDumpFormatMemoryEnc:  Failed to identify encoding handler for character set 'ISO-8859-15'
		return $this->dom->dump_mem($format, $this->config['encoding']);
	}

	function _recArray2Node($parent_node, $array)
	{
		if (is_array($array))
			foreach ($array as $key => $value)
			{
				$org_key = $key;
				$key = str_replace("@", "", $org_key);

				if (substr($org_key, 0, 1) == '@')
				{
					// attribute
					if ($key == "__xmlns") //ripristino xmlns
						$key = "xmlns";

					$parent_node->set_attribute($key, $value);
					continue;
				}

				else
					if ($key == '#text' || !is_array($value))
					{
						// text node
						// check if valid text & not empty
						//if ( $value=='0' | !empty($value) )
						if (isset ($value))
						{
							$element = $this->dom->create_text_node($value);
							if (is_object($parent_node))
								$parent_node->append_child($element);
						}
						continue;
					}

					else
					{
						if (strstr($key, "^")) //splxsplx
							$key = substr($key, 0, strrpos($key, "^"));
						$element = $this->dom->create_element($key);
						$parent_node->append_child($element);
						$this->_recArray2Node($element, $value);
					}
			}
	}
}
?>